org.jboss.netty.channel.group

## Interface ChannelGroupFuture

All Superinterfaces:
  Iterable<ChannelFuture>

All Known Implementing Classes:
  DefaultChannelGroupFuture

    public interface ChannelGroupFuture
    extends Iterable<ChannelFuture>

The result of an asynchronous `ChannelGroup` operation. `ChannelGroupFuture` is composed of `ChannelFuture`s which represent the outcome of the individual I/O operations that affect the `Channel`s in the `ChannelGroup`.

All I/O operations in `ChannelGroup` are asynchronous. It means any I/O calls will return immediately with no guarantee that the requested I/O operations have been completed at the end of the call. Instead, you will be returned with a `ChannelGroupFuture` instance which tells you when the requested I/O operations have succeeded, failed, or cancelled.

Various methods are provided to let you check if the I/O operations has been completed, wait for the completion, and retrieve the result of the I/O operation. It also allows you to add more than one `ChannelGroupFutureListener` so you can get notified when the I/O operation have been completed.

### Prefer `addListener(ChannelGroupFutureListener)` to `await()`

It is recommended to prefer `addListener(ChannelGroupFutureListener)` to `await()` wherever possible to get notified when I/O operations are done and to do any follow-up tasks.

`addListener(ChannelGroupFutureListener)` is non-blocking. It simply adds the specified `ChannelGroupFutureListener` to the `ChannelGroupFuture`, and I/O thread will notify the listeners when the I/O operations associated with the future is done. `ChannelGroupFutureListener` yields the best performance and resource utilization because it does not block at all, but it could be tricky to implement a sequential logic if you are not used to event-driven programming.

By contrast, `await()` is a blocking operation. Once called, the caller thread blocks until all I/O operations are done. It is easier to implement a sequential logic with `await()`, but the caller thread blocks unnecessarily until all I/O operations are done and there's relatively expensive cost of inter-thread notification. Moreover, there's a chance of dead lock in a particular circumstance, which is described below.

### Do not call `await()` inside `ChannelHandler`

The event handler methods in `ChannelHandler` is often called by an I/O thread unless an `ExecutionHandler` is in the `ChannelPipeline`. If `await()` is called by an event handler method, which is called by the I/O thread, the I/O operation it is waiting for might never be complete because `await()` can block the I/O operation it is waiting for, which is a dead lock.

     // BAD - NEVER DO THIS
     @Override
     public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) {
         if (e.getMessage() instanceof ShutdownMessage) {
             ChannelGroup allChannels = MyServer.getAllChannels();
             ChannelGroupFuture future = allChannels.close();
             future.awaitUninterruptibly();
             // Perform post-shutdown operation
             // ...
         }
     }

     // GOOD
     @Override
     public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) {
         if (e.getMessage() instanceof ShutdownMessage) {
             ChannelGroup allChannels = MyServer.getAllChannels();
             ChannelGroupFuture future = allChannels.close();
             future.addListener(new ChannelGroupFutureListener() {
                 public void operationComplete(ChannelGroupFuture future) {
                     // Perform post-closure operation
                     // ...
                 }
             });
         }
     }

In spite of the disadvantages mentioned above, there are certainly the cases where it is more convenient to call `await()`. In such a case, please make sure you do not call `await()` in an I/O thread. Otherwise, `IllegalStateException` will be raised to prevent a dead lock.

### Method Summary

Methods
`void` `addListener(ChannelGroupFutureListener listener)` Adds the specified listener to this future.
`ChannelGroupFuture` `await()` Waits for this future to be completed.
`boolean` `await(long timeoutMillis)` Waits for this future to be completed within the specified time limit.
`boolean` `await(long timeout, TimeUnit unit)` Waits for this future to be completed within the specified time limit.
`ChannelGroupFuture` `awaitUninterruptibly()` Waits for this future to be completed without interruption.
`boolean` `awaitUninterruptibly(long timeoutMillis)` Waits for this future to be completed within the specified time limit without interruption.
`boolean` `awaitUninterruptibly(long timeout, TimeUnit unit)` Waits for this future to be completed within the specified time limit without interruption.
`ChannelFuture` `find(Channel channel)` Returns the `ChannelFuture` of the individual I/O operation which is associated with the specified `Channel`.
`ChannelFuture` `find(Integer channelId)` Returns the `ChannelFuture` of the individual I/O operation which is associated with the `Channel` whose ID matches the specified integer.
`ChannelGroup` `getGroup()` Returns the `ChannelGroup` which is associated with this future.
`boolean` `isCompleteFailure()` Returns `true` if and only if all I/O operations associated with this future have failed without any success.
`boolean` `isCompleteSuccess()` Returns `true` if and only if all I/O operations associated with this future were successful without any failure.
`boolean` `isDone()` Returns `true` if and only if this future is complete, regardless of whether the operation was successful, failed, or canceled.
`boolean` `isPartialFailure()` Returns `true` if and only if the I/O operations associated with this future have failed partially with some success.
`boolean` `isPartialSuccess()` Returns `true` if and only if the I/O operations associated with this future were partially successful with some failure.
`Iterator<ChannelFuture>` `iterator()` Returns the `Iterator` that enumerates all `ChannelFuture`s which are associated with this future.
`void` `removeListener(ChannelGroupFutureListener listener)` Removes the specified listener from this future.

### Method Detail

#### getGroup

    ChannelGroup getGroup()

Returns the `ChannelGroup` which is associated with this future.

#### find

    ChannelFuture find(Integer channelId)

Returns the `ChannelFuture` of the individual I/O operation which is associated with the `Channel` whose ID matches the specified integer.

Returns:
  the matching `ChannelFuture` if found. `null` otherwise.

#### find

    ChannelFuture find(Channel channel)

Returns the `ChannelFuture` of the individual I/O operation which is associated with the specified `Channel`.

Returns:
  the matching `ChannelFuture` if found. `null` otherwise.

#### isDone

    boolean isDone()

Returns `true` if and only if this future is complete, regardless of whether the operation was successful, failed, or canceled.

#### isCompleteSuccess

    boolean isCompleteSuccess()

Returns `true` if and only if all I/O operations associated with this future were successful without any failure.

#### isPartialSuccess

    boolean isPartialSuccess()

Returns `true` if and only if the I/O operations associated with this future were partially successful with some failure.

#### isCompleteFailure

    boolean isCompleteFailure()

Returns `true` if and only if all I/O operations associated with this future have failed without any success.

#### isPartialFailure

    boolean isPartialFailure()

Returns `true` if and only if the I/O operations associated with this future have failed partially with some success.

#### addListener

    void addListener(ChannelGroupFutureListener listener)

Adds the specified listener to this future. The specified listener is notified when this future is done. If this future is already completed, the specified listener is notified immediately.

#### removeListener

    void removeListener(ChannelGroupFutureListener listener)

Removes the specified listener from this future. The specified listener is no longer notified when this future is done. If this future is already completed, this method has no effect and returns silently.

#### await

    ChannelGroupFuture await()
                             throws InterruptedException

Waits for this future to be completed.

Throws:
  `InterruptedException` - if the current thread was interrupted

#### awaitUninterruptibly

    ChannelGroupFuture awaitUninterruptibly()

Waits for this future to be completed without interruption. This method catches an `InterruptedException` and discards it silently.

#### await

    boolean await(long timeout,
                TimeUnit unit)
                  throws InterruptedException

Waits for this future to be completed within the specified time limit.

Returns:
  `true` if and only if the future was completed within the specified time limit
Throws:
  `InterruptedException` - if the current thread was interrupted

#### await

    boolean await(long timeoutMillis)
                  throws InterruptedException

Waits for this future to be completed within the specified time limit.

Returns:
  `true` if and only if the future was completed within the specified time limit
Throws:
  `InterruptedException` - if the current thread was interrupted

#### awaitUninterruptibly

    boolean awaitUninterruptibly(long timeout,
                               TimeUnit unit)

Waits for this future to be completed within the specified time limit without interruption. This method catches an `InterruptedException` and discards it silently.

Returns:
  `true` if and only if the future was completed within the specified time limit

#### awaitUninterruptibly

    boolean awaitUninterruptibly(long timeoutMillis)

Waits for this future to be completed within the specified time limit without interruption. This method catches an `InterruptedException` and discards it silently.

Returns:
  `true` if and only if the future was completed within the specified time limit

#### iterator

    Iterator<ChannelFuture> iterator()

Returns the `Iterator` that enumerates all `ChannelFuture`s which are associated with this future. Please note that the returned `Iterator` is is unmodifiable, which means a `ChannelFuture` cannot be removed from this future.

Specified by:
  `iterator` in interface `Iterable<ChannelFuture>`